<!-- src/views/StatusPage.vue -->

<template>
  <div class="mt-8 lg:mt-8 pb-1 lg:pb-3">
    <h1 class="mb-3">Results Dashboard</h1>
  </div>

  <div class="surface-card p-4 shadow-2 border-round w-full m-auto">
    <table class="w-full">
      <thead>
        <tr>
          <th class="w-3rem pb-2">ID</th>
          <th class="w-auto pb-2">Name</th>
          <th class="w-9rem pb-2">Student ID</th>
          <th class="w-9rem pb-2">Date</th>
          <th class="w-9rem pb-2">Result</th>
          <th class="w-6rem pb-2">Photo</th>
          <th class="w-6rem pb-2">Status</th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="(result, index) in paginatedResults"
          :key="result.id"
          :class="{ 'border-bottom-1': index !== paginatedResults.length - 1 }"
        >
          <td class="py-2">{{ result.id }}</td>
          <td class="py-2">{{ result.name }}</td>
          <td class="py-2">{{ result.studentId }}</td>
          <td class="py-2">{{ formatDate(result.date) }}</td>
          <td class="py-2" :class="result.result === 1 ? 'text-red-500' : 'text-green-500'">
            {{ result.result === 1 ? 'Positive' : 'Negative' }}
          </td>
          <td class="py-2"><span class="py-1 px-2 bg-gray-300 text-black">Show</span></td>
          <td class="py-2">
            <span :class="statusClass(result.status)" class="py-1 px-2">{{ statusText(result.status) }}</span>
          </td>
        </tr>
      </tbody>
    </table>

    <div class="mt-5 flex justify-content-end align-content-center">
      <div class="p-3 flex align-content-center cursor-pointer" @click="previousPage" :disabled="currentPage <= 1">
        <span class="text-2xl"><</span>
      </div>
      <div class="px-3 flex flex-wrap align-content-center align-items-stretch">
        <span class="">Page {{ currentPage }} of {{ totalPages }}</span>
      </div>
      <div class="p-3 flex align-content-center cursor-pointer" @click="nextPage" :disabled="currentPage >= totalPages">
        <span class="text-2xl">></span>
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref, computed, onMounted } from 'vue';
import { useResultsStore } from '@/stores/resultsStore';

const resultsStore = useResultsStore();
const results = ref([]);
const loading = ref(false);
const error = ref(null);

const pageSize = ref(5);
const currentPage = ref(1);

onMounted(async () => {
  loading.value = true;
  try {
    await resultsStore.fetchAllResults();
    results.value = resultsStore.results;
  } catch (e) {
    error.value = 'Failed to fetch results';
    console.error(e);
  } finally {
    loading.value = false;
  }
});

const paginatedResults = computed(() => {
  const start = (currentPage.value - 1) * pageSize.value;
  return results.value.slice(start, start + pageSize.value);
});

const totalPages = computed(() => {
  return Math.ceil(results.value.length / pageSize.value);
});

function previousPage() {
  if (currentPage.value > 1) currentPage.value--;
}

function nextPage() {
  if (currentPage.value < totalPages.value) currentPage.value++;
}

const formatDate = (dateString) => {
  const date = new Date(dateString);
  return date.toLocaleDateString();
};

function statusClass(status) {
  switch (status) {
    case 0:
      return 'bg-yellow-400 text-white';
    case 1:
      return 'bg-green-500 text-white';
    case 2:
      return 'bg-red-600 text-white';
  }
}

function statusText(status) {
  switch (status) {
    case 0:
      return 'Waiting';
    case 1:
      return 'Approved';
    case 2:
      return 'Declined';
  }
}
</script>
